<?php
/*
 * Pipedrive
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace Pipedrive\Models;

use JsonSerializable;

/**
 *The array of Deals filtered by name
 */
class Data23 implements JsonSerializable
{
    /**
     * The ID of the Deal
     * @var integer|null $id public property
     */
    public $id;

    /**
     * The title of the Deal
     * @var string|null $title public property
     */
    public $title;

    /**
     * The ID of the User who is associated with the Deal
     * @maps user_id
     * @var integer|null $userId public property
     */
    public $userId;

    /**
     * The visibility of the Deal
     * @maps visible_to
     * @var string|null $visibleTo public property
     */
    public $visibleTo;

    /**
     * The status of the Deal
     * @var string|null $status public property
     */
    public $status;

    /**
     * The value of the Deal
     * @var double|null $value public property
     */
    public $value;

    /**
     * The currency associated with the Deal
     * @var string|null $currency public property
     */
    public $currency;

    /**
     * The name of the Person associated with the Deal
     * @maps person_name
     * @var string|null $personName public property
     */
    public $personName;

    /**
     * The ID of the Person associated with the Deal
     * @maps person_id
     * @var integer|null $personId public property
     */
    public $personId;

    /**
     * The name of the Organization associated with the Deal
     * @maps organization_name
     * @var string|null $organizationName public property
     */
    public $organizationName;

    /**
     * The ID of the Person associated with the Deal
     * @maps organization_id
     * @var integer|null $organizationId public property
     */
    public $organizationId;

    /**
     * The Deal value formatted with selected currency. E.g. US$500
     * @maps formatted_value
     * @var string|null $formattedValue public property
     */
    public $formattedValue;

    /**
     * The Cc email of the Deal
     * @maps cc_email
     * @var string|null $ccEmail public property
     */
    public $ccEmail;

    /**
     * Constructor to set initial or default values of member properties
     * @param integer $id               Initialization value for $this->id
     * @param string  $title            Initialization value for $this->title
     * @param integer $userId           Initialization value for $this->userId
     * @param string  $visibleTo        Initialization value for $this->visibleTo
     * @param string  $status           Initialization value for $this->status
     * @param double  $value            Initialization value for $this->value
     * @param string  $currency         Initialization value for $this->currency
     * @param string  $personName       Initialization value for $this->personName
     * @param integer $personId         Initialization value for $this->personId
     * @param string  $organizationName Initialization value for $this->organizationName
     * @param integer $organizationId   Initialization value for $this->organizationId
     * @param string  $formattedValue   Initialization value for $this->formattedValue
     * @param string  $ccEmail          Initialization value for $this->ccEmail
     */
    public function __construct()
    {
        if (13 == func_num_args()) {
            $this->id               = func_get_arg(0);
            $this->title            = func_get_arg(1);
            $this->userId           = func_get_arg(2);
            $this->visibleTo        = func_get_arg(3);
            $this->status           = func_get_arg(4);
            $this->value            = func_get_arg(5);
            $this->currency         = func_get_arg(6);
            $this->personName       = func_get_arg(7);
            $this->personId         = func_get_arg(8);
            $this->organizationName = func_get_arg(9);
            $this->organizationId   = func_get_arg(10);
            $this->formattedValue   = func_get_arg(11);
            $this->ccEmail          = func_get_arg(12);
        }
    }


    /**
     * Encode this object to JSON
     */
    public function jsonSerialize()
    {
        $json = array();
        $json['id']                = $this->id;
        $json['title']             = $this->title;
        $json['user_id']           = $this->userId;
        $json['visible_to']        = $this->visibleTo;
        $json['status']            = $this->status;
        $json['value']             = $this->value;
        $json['currency']          = $this->currency;
        $json['person_name']       = $this->personName;
        $json['person_id']         = $this->personId;
        $json['organization_name'] = $this->organizationName;
        $json['organization_id']   = $this->organizationId;
        $json['formatted_value']   = $this->formattedValue;
        $json['cc_email']          = $this->ccEmail;

        return $json;
    }
}
