<?php
/*
 * Pipedrive
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace Pipedrive\Models;

use JsonSerializable;

/**
 *Member of a thread
 */
class MailThreadParticipant implements JsonSerializable
{
    /**
     * ID of the mail thread participant
     * @var integer|null $id public property
     */
    public $id;

    /**
     * Name of the mail thread participant
     * @var string|null $name public property
     */
    public $name;

    /**
     * Whether the mail thread participant was last to send an email
     * @maps latest_sent
     * @var bool|null $latestSent public property
     */
    public $latestSent;

    /**
     * Email address of the mail thread participant
     * @maps email_address
     * @var string|null $emailAddress public property
     */
    public $emailAddress;

    /**
     * Message time
     * @maps message_time
     * @var double|null $messageTime public property
     */
    public $messageTime;

    /**
     * ID of the linked person
     * @maps linked_person_id
     * @var integer|null $linkedPersonId public property
     */
    public $linkedPersonId;

    /**
     * Email of the linked person
     * @maps linked_person_name
     * @var string|null $linkedPersonName public property
     */
    public $linkedPersonName;

    /**
     * ID of the mail message party
     * @maps mail_message_party_id
     * @var integer|null $mailMessagePartyId public property
     */
    public $mailMessagePartyId;

    /**
     * Linked Organization ID
     * @maps linked_organization_id
     * @var integer|null $linkedOrganizationId public property
     */
    public $linkedOrganizationId;

    /**
     * Constructor to set initial or default values of member properties
     * @param integer $id                   Initialization value for $this->id
     * @param string  $name                 Initialization value for $this->name
     * @param bool    $latestSent           Initialization value for $this->latestSent
     * @param string  $emailAddress         Initialization value for $this->emailAddress
     * @param double  $messageTime          Initialization value for $this->messageTime
     * @param integer $linkedPersonId       Initialization value for $this->linkedPersonId
     * @param string  $linkedPersonName     Initialization value for $this->linkedPersonName
     * @param integer $mailMessagePartyId   Initialization value for $this->mailMessagePartyId
     * @param integer $linkedOrganizationId Initialization value for $this->linkedOrganizationId
     */
    public function __construct()
    {
        if (9 == func_num_args()) {
            $this->id                   = func_get_arg(0);
            $this->name                 = func_get_arg(1);
            $this->latestSent           = func_get_arg(2);
            $this->emailAddress         = func_get_arg(3);
            $this->messageTime          = func_get_arg(4);
            $this->linkedPersonId       = func_get_arg(5);
            $this->linkedPersonName     = func_get_arg(6);
            $this->mailMessagePartyId   = func_get_arg(7);
            $this->linkedOrganizationId = func_get_arg(8);
        }
    }


    /**
     * Encode this object to JSON
     */
    public function jsonSerialize()
    {
        $json = array();
        $json['id']                     = $this->id;
        $json['name']                   = $this->name;
        $json['latest_sent']            = $this->latestSent;
        $json['email_address']          = $this->emailAddress;
        $json['message_time']           = $this->messageTime;
        $json['linked_person_id']       = $this->linkedPersonId;
        $json['linked_person_name']     = $this->linkedPersonName;
        $json['mail_message_party_id']  = $this->mailMessagePartyId;
        $json['linked_organization_id'] = $this->linkedOrganizationId;

        return $json;
    }
}
