<?php
/*
 * Pipedrive
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace Pipedrive\Models;

use JsonSerializable;

/**
 * @todo Write general description for this model
 */
class OrganizationRelationship implements JsonSerializable
{
    /**
     * ID of the base organization for the returned calculated values
     * @maps org_id
     * @var integer|null $orgId public property
     */
    public $orgId;

    /**
     * The type of organization relationship.
     * @var string|null $type public property
     */
    public $type;

    /**
     * The owner of this relationship. If type is 'parent', then the owner is the parent and the linked
     * organization is the daughter.
     * @maps rel_owner_org_id
     * @var integer|null $relOwnerOrgId public property
     */
    public $relOwnerOrgId;

    /**
     * The linked organization in this relationship. If type is 'parent', then the linked organization is
     * the daughter.
     * @maps rel_linked_org_id
     * @var integer|null $relLinkedOrgId public property
     */
    public $relLinkedOrgId;

    /**
     * Constructor to set initial or default values of member properties
     * @param integer $orgId          Initialization value for $this->orgId
     * @param string  $type           Initialization value for $this->type
     * @param integer $relOwnerOrgId  Initialization value for $this->relOwnerOrgId
     * @param integer $relLinkedOrgId Initialization value for $this->relLinkedOrgId
     */
    public function __construct()
    {
        if (4 == func_num_args()) {
            $this->orgId          = func_get_arg(0);
            $this->type           = func_get_arg(1);
            $this->relOwnerOrgId  = func_get_arg(2);
            $this->relLinkedOrgId = func_get_arg(3);
        }
    }


    /**
     * Encode this object to JSON
     */
    public function jsonSerialize()
    {
        $json = array();
        $json['org_id']            = $this->orgId;
        $json['type']              = $this->type;
        $json['rel_owner_org_id']  = $this->relOwnerOrgId;
        $json['rel_linked_org_id'] = $this->relLinkedOrgId;

        return $json;
    }
}
