<?php
/*
 * Pipedrive
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace Pipedrive\Models;

use JsonSerializable;

/**
 * @todo Write general description for this model
 */
class ProductAttachementFields implements JsonSerializable
{
    /**
     * The ID of the deal-product (the ID of the Product attached to the Deal)
     * @var integer|null $id public property
     */
    public $id;

    /**
     * The ID of the Company
     * @maps company_id
     * @var integer|null $companyId public property
     */
    public $companyId;

    /**
     * The ID of the Deal
     * @maps deal_id
     * @var integer|null $dealId public property
     */
    public $dealId;

    /**
     * The ID of the Product
     * @maps product_id
     * @var integer|null $productId public property
     */
    public $productId;

    /**
     * The type of the duration. (For example hourly, daily, etc.)
     * @maps duration_unit
     * @var string|null $durationUnit public property
     */
    public $durationUnit;

    /**
     * The Product sum without the discount
     * @maps sum_no_discount
     * @var double|null $sumNoDiscount public property
     */
    public $sumNoDiscount;

    /**
     * The sum of all the Products attached to the Deal
     * @var double|null $sum public property
     */
    public $sum;

    /**
     * The currency associated with the Deal Product
     * @var string|null $currency public property
     */
    public $currency;

    /**
     * The date and time when the Product was added to the Deal
     * @maps add_time
     * @var string|null $addTime public property
     */
    public $addTime;

    /**
     * The date and time when the Deal Product was last edited
     * @maps last_edit
     * @var string|null $lastEdit public property
     */
    public $lastEdit;

    /**
     * Boolean indicates if the Product is activated or not
     * @maps active_flag
     * @var bool|null $activeFlag public property
     */
    public $activeFlag;

    /**
     * The Product tax
     * @var double|null $tax public property
     */
    public $tax;

    /**
     * The Product name
     * @var string|null $name public property
     */
    public $name;

    /**
     * Constructor to set initial or default values of member properties
     * @param integer $id            Initialization value for $this->id
     * @param integer $companyId     Initialization value for $this->companyId
     * @param integer $dealId        Initialization value for $this->dealId
     * @param integer $productId     Initialization value for $this->productId
     * @param string  $durationUnit  Initialization value for $this->durationUnit
     * @param double  $sumNoDiscount Initialization value for $this->sumNoDiscount
     * @param double  $sum           Initialization value for $this->sum
     * @param string  $currency      Initialization value for $this->currency
     * @param string  $addTime       Initialization value for $this->addTime
     * @param string  $lastEdit      Initialization value for $this->lastEdit
     * @param bool    $activeFlag    Initialization value for $this->activeFlag
     * @param double  $tax           Initialization value for $this->tax
     * @param string  $name          Initialization value for $this->name
     */
    public function __construct()
    {
        if (13 == func_num_args()) {
            $this->id            = func_get_arg(0);
            $this->companyId     = func_get_arg(1);
            $this->dealId        = func_get_arg(2);
            $this->productId     = func_get_arg(3);
            $this->durationUnit  = func_get_arg(4);
            $this->sumNoDiscount = func_get_arg(5);
            $this->sum           = func_get_arg(6);
            $this->currency      = func_get_arg(7);
            $this->addTime       = func_get_arg(8);
            $this->lastEdit      = func_get_arg(9);
            $this->activeFlag    = func_get_arg(10);
            $this->tax           = func_get_arg(11);
            $this->name          = func_get_arg(12);
        }
    }


    /**
     * Encode this object to JSON
     */
    public function jsonSerialize()
    {
        $json = array();
        $json['id']              = $this->id;
        $json['company_id']      = $this->companyId;
        $json['deal_id']         = $this->dealId;
        $json['product_id']      = $this->productId;
        $json['duration_unit']   = $this->durationUnit;
        $json['sum_no_discount'] = $this->sumNoDiscount;
        $json['sum']             = $this->sum;
        $json['currency']        = $this->currency;
        $json['add_time']        = $this->addTime;
        $json['last_edit']       = $this->lastEdit;
        $json['active_flag']     = $this->activeFlag;
        $json['tax']             = $this->tax;
        $json['name']            = $this->name;

        return $json;
    }
}
