<?php
/*
 * Pipedrive
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace Pipedrive\Models;

use JsonSerializable;

/**
 *The details of the sub-role
 */
class SubRole implements JsonSerializable
{
    /**
     * The ID of the parent Role
     * @maps parent_role_id
     * @var integer|null $parentRoleId public property
     */
    public $parentRoleId;

    /**
     * The name of the Role
     * @var string|null $name public property
     */
    public $name;

    /**
     * The ID of the Role
     * @var integer|null $id public property
     */
    public $id;

    /**
     * If the Role is active or not
     * @maps active_flag
     * @var bool|null $activeFlag public property
     */
    public $activeFlag;

    /**
     * The number of Users assigned to this Role
     * @maps assignment_count
     * @var string|null $assignmentCount public property
     */
    public $assignmentCount;

    /**
     * The number of sub-roles
     * @maps sub_role_count
     * @var string|null $subRoleCount public property
     */
    public $subRoleCount;

    /**
     * Constructor to set initial or default values of member properties
     * @param integer $parentRoleId    Initialization value for $this->parentRoleId
     * @param string  $name            Initialization value for $this->name
     * @param integer $id              Initialization value for $this->id
     * @param bool    $activeFlag      Initialization value for $this->activeFlag
     * @param string  $assignmentCount Initialization value for $this->assignmentCount
     * @param string  $subRoleCount    Initialization value for $this->subRoleCount
     */
    public function __construct()
    {
        if (6 == func_num_args()) {
            $this->parentRoleId    = func_get_arg(0);
            $this->name            = func_get_arg(1);
            $this->id              = func_get_arg(2);
            $this->activeFlag      = func_get_arg(3);
            $this->assignmentCount = func_get_arg(4);
            $this->subRoleCount    = func_get_arg(5);
        }
    }


    /**
     * Encode this object to JSON
     */
    public function jsonSerialize()
    {
        $json = array();
        $json['parent_role_id']   = $this->parentRoleId;
        $json['name']             = $this->name;
        $json['id']               = $this->id;
        $json['active_flag']      = $this->activeFlag;
        $json['assignment_count'] = $this->assignmentCount;
        $json['sub_role_count']   = $this->subRoleCount;

        return $json;
    }
}
