<?php
/*
 * Pipedrive
 *
 * This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
 */

namespace Pipedrive\Models;

use JsonSerializable;

/**
 *The total weighted values of the Deals grouped by Deal currency. The weighted value is calculated
 * as probability times Deal value.
 */
class WeightedValuesTotal implements JsonSerializable
{
    /**
     * The total weighted value of the Deals in the Deal currency group
     * @var double|null $value public property
     */
    public $value;

    /**
     * The number of Deals in the Deal currency group
     * @var integer|null $count public property
     */
    public $count;

    /**
     * The total weighted value of the Deals formatted with Deal currency. E.g. €50
     * @maps value_formatted
     * @var string|null $valueFormatted public property
     */
    public $valueFormatted;

    /**
     * Constructor to set initial or default values of member properties
     * @param double  $value          Initialization value for $this->value
     * @param integer $count          Initialization value for $this->count
     * @param string  $valueFormatted Initialization value for $this->valueFormatted
     */
    public function __construct()
    {
        if (3 == func_num_args()) {
            $this->value          = func_get_arg(0);
            $this->count          = func_get_arg(1);
            $this->valueFormatted = func_get_arg(2);
        }
    }


    /**
     * Encode this object to JSON
     */
    public function jsonSerialize()
    {
        $json = array();
        $json['value']           = $this->value;
        $json['count']           = $this->count;
        $json['value_formatted'] = $this->valueFormatted;

        return $json;
    }
}
